;(function () {
  // Adding the GA library and registering the project, this (and more) is available from the GA docs
  (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)})(window,document,'script','https://www.google-analytics.com/analytics.js','ga');
  ga('create', 'UA-153495934-1', 'auto');

  // Sends a page view event when the page loaded
  ga('send', 'pageview');

  var styles = {
    err: 'background: darkred; color: white; padding: 4px 12px; border-radius: 4px; margin-bottom: 50px; border-bottom: solid 1px',
    success: 'background: seagreen; color: white; padding: 4px 12px; border-radius: 4px; margin-bottom: 50px; border-bottom: solid 1px',
  }

  // A page name must be specified when setting up the Hype doc
  // This is used to create a unique data set and allow the
  // project's activity to be tracked accurately
  var pageName = document.querySelector('title').innerText;

  function handleGaClick (target) {
    // Class names are used to determine if we should do something when that element is clicked. 
    // Get and store the classList as an Array (the default is a tokenList) for the element clicked
    var classList = Array.from(target.classList);

    // Check if the class list includes specific class names that should trigger events and fire it
    // Here we check if it has a button class...
    console.log('A tracking button was clicked!', { classList })

    // And then we find the matching scene class name
    var scene = classList.find(function (c) {
      return c.includes('scene_');
    });

    // And then we find the matching context class name
    // Context is typicaly used to infer the nature of element that was interacted with
    // (eg: Pagination, menu etc)
    var context = classList.find(function (c) {
      return c.includes('context_');
    });

    var action = classList.find(function (c) {
      return c.includes('action_')
    }) || 'click'

    // An additional check is performed in case a scene name wasn't specified and a placeholder is added.
    // This will not provide as accurate data but will prevent runtime errors or data-loss
    if (!scene) {
      scene = 'sceneChanged';
    };
    // An additional check is performed in case a context wasn't specified and a placeholder is added.
    // This will not provide as accurate data but will prevent runtime errors or data-loss
    if (!context) {
      context = '';
    };

    var gaEvent = {
      hitType: 'event',
      eventCategory: pageName, // Name of the project - This should changed for each project
      eventAction: action, // Type of interactive
      eventLabel: scene + ' | ' + context, // Name of the scene being navigated to
    }

    // Adds analytics tracking for button clicks
    console.log('Sending event to Google', gaEvent)
    ga('send', 'event', gaEvent);

    console.log('%c Done', styles.success)
  };

  function delegate (target) {
    console.log('Checking target: ',{ target })
    if (target.classList && Array.from(target.classList).includes('gaButton')) {
      // if there is a classlist and it has the gaButton; do stuff
      console.log('%cButton found', styles.success)
      return handleGaClick(target)
    } else {
      // If the gaButton class is not found, walk up the DOM tree recursively
      var parent = target.parentNode
      if (parent) {
        return delegate(parent)
      } else {
        // No parent to check? Stop everything
        console.log('%cUh oh, no more parents', styles.err)
        return
      }
    }
  }

  const mobile = /iPad|Android|webOS|iPhone|iPod|Blackberry/.test(navigator.userAgent) && !window.MSStream
  const trackEvent = mobile ? 'touchend' : 'click'

  window.addEventListener(trackEvent, function (e) {
    console.log('target', e.target)
    delegate(e.target)
  })

})();
